<template>
  <app-form title="Create Board" :open="open" @close="cancelCreate">
    <form-group labelFor="form-create-board-name" label="Board Name">
      <form-input
        id="form-create-board-name"
        v-model="name"
        placeholder="Please Provide the name of the board..."
      ></form-input>
    </form-group>
    <template v-slot:footer>
      <button @click="createBoard" type="button" class="btn btn-primary">
        Create
      </button>
      <button @click="cancelCreate" type="button" class="btn btn-light">
        Cancel
      </button>
    </template>
  </app-form>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { v4 as uuidV4 } from "uuid";
import AppForm from "../components/Form.vue";
import FormGroup from "../components/FormGroup.vue";
import FormInput from "../components/FormInput.vue";
import { Board } from "@/core/database";

export default defineComponent({
  components: { AppForm, FormGroup, FormInput },
  emits: ["create", "cancel"],
  props: {
    open: {
      type: Boolean,
      required: true,
    },
  },
  data() {
    return {
      name: "",
    };
  },
  methods: {
    createBoard() {
      const board = new Board(uuidV4(), this.name);
      this.$emit("create", board);
      this.cancelCreate();
    },
    cancelCreate() {
      this.$emit("cancel");
    },
  },
});
</script>
